package index

import (
	"time"
)

// 钢联化工指标数据
type BaseFromMysteelChemicalIndex struct {
	BaseFromMysteelChemicalIndexId int64     `gorm:"primaryKey;column:base_from_mysteel_chemical_index_id;type:int(11);not null"` //序号
	IndexCode                      string    `gorm:"column:index_code"`
	IndexName                      string    `gorm:"column:index_name"`
	Unit                           string    `gorm:"column:unit"`
	Source                         string    `gorm:"column:source"`
	Frequency                      string    `gorm:"column:frequency"`
	StartDate                      time.Time `gorm:"column:start_date"`
	EndDate                        time.Time `gorm:"column:end_date"`
	Describe                       string    `gorm:"column:describe"`
	UpdateWeek                     string    `gorm:"column:update_week"`
	UpdateTime                     string    `gorm:"column:update_time"`
	UpdateTime2                    string    `gorm:"column:update_time2"`
	SysUserId                      int       `gorm:"column:sys_user_id"`
	SysUserRealName                string    `gorm:"column:sys_user_real_name"`
	FilePath                       string    `gorm:"column:file_path"`
	MergeFilePath                  string    `gorm:"column:merge_file_path"`
	FileIndex                      int       `gorm:"column:file_index"`
	MergeUpdateWeek                string    `gorm:"column:merge_update_week"`
	UpdateDate                     string    `gorm:"column:update_date"`
	CreateTime                     time.Time `gorm:"autoCreateTime;column:create_time"`       //创建时间
	ModifyTime                     time.Time `gorm:"autoUpdateTime:milli;column:modify_time"` //最后更新时间
}

type IndexAddReq struct {
	IndexCode  string `json:"IndexCode" binding:"required"`                       //指标编码
	UpdateWeek string `json:"UpdateWeek"`                                         //更新周期
	RunMode    string `description:"运行环境:debug:测试(默认),release:生产" json:"RunMode"` //更新周期
}

type IndexRefreshReq struct {
	MergeFilePath string `json:"MergeFilePath" binding:"required"` //指标编码
}
